<?php

namespace App\Http\Resources;

use Illuminate\Http\Request;
use Illuminate\Http\Resources\Json\JsonResource;

class ComponentResource extends JsonResource
{
    /**
     * Transform the resource into an array.
     *
     * @return array<string, mixed>
     */
    public function toArray(Request $request): array
    {
        return [
            'id' => $this->id,
            'order' => $this->order,
            'status' => $this->status,
            'type' => new ComponentTypeRessource($this->type),
            'page_id' => $this->page_id,
            'parent_id' => $this->parent_id,
            'children' => ComponentResource::collection($this->children),
            'parameters' => ParameterRessource::collection($this->parameters)
        ];
    }
}
