<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('menus', function (Blueprint $table) {
            $table->uuid('id')->primary();
            $table->timestamps();
            $table->string('name');
            $table->enum('type', ['link', 'dropdown'])->default('link');
            $table->string('url')->nullable();
            $table->foreignUuid('parent_id')->nullable()->constrained('menus');
            $table->integer('order')->nullable();
            $table->enum('status', ['draft', 'published'])->default('draft');
            $table->enum('navbar', ['nav-1', 'nav-2', 'footer'])->default('nav-1');
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('menus');
    }
};
